<template>
  <div>
    <p>
      ANTARES ingests gravitational wave events from the
      <a
        href="https://gcn.nasa.gov/"
        target="_blank"
      >
        NASA GCN
      </a>
      streaming and performs cross-matching with the alerts associated to a locus.
      Here you will find details of the gravitational wave events associated to this locus.
    </p>
    <div v-if="locus.grav_wave_events.length">
      <div
        v-for="eventId in locus.grav_wave_events"
        :key="eventId"
        class="pb-3"
      >
        <h2 class="pb-1">
          Event ID: {{ eventId }}
          <a
            v-b-tooltip.v-primary.hover.right
            :href="getTreasureMapLink(eventId)"
            class="pl-1 external-link"
            target="_blank"
            title="Go to Treasure Map (note: event might not exist in their database)"
          >
            <font-awesome-icon icon="external-link-alt" />
          </a>
        </h2>
        <LocusGravWaveTable :grav-wave-alerts="alertsByEventId[eventId] || []" />
      </div>
    </div>
    <div v-else>
      <b-list-group>
        <b-list-group-item variant="warning">
          <strong>No gravitational wave events associated to this locus</strong>
        </b-list-group-item>
      </b-list-group>
    </div>
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { Alert, GravWaveAlert, Locus } from '@/common/types';
import LocusGravWaveTable from '@/components/Locus/GravWaveTable.vue';

interface GravWaveAlertsByEvent {
  [key: string]: GravWaveAlert[];
}

export default Vue.extend({
  components: {
    LocusGravWaveTable,
  },

  props: {
    alerts: {
      required: true,
      type: Array,
    } as PropOptions<Alert[]>,
    locus: {
      required: true,
      type: Object,
    } as PropOptions<Locus>,
  },

  computed: {
    alertsByEventId(): GravWaveAlertsByEvent {
      return this.alerts
        .filter((alert) => alert.grav_wave_events.length)
        .map(
          (alert) => alert.grav_wave_events.map(
            (event) => ({
              ...event,
              id: alert.id,
              mjd: alert.mjd,
              properties: alert.properties,
            } as GravWaveAlert),
          ),
        )
        .flat()
        .reduce((alertsByEventId: GravWaveAlertsByEvent, gravWaveAlert: GravWaveAlert) => ({
          ...alertsByEventId,
          [gravWaveAlert.gracedb_id]: [
            ...(alertsByEventId[gravWaveAlert.gracedb_id] || []),
            gravWaveAlert,
          ],
        }), {});
    },
  },

  methods: {
    getTreasureMapLink(eventId: string) {
      return `https://treasuremap.space/alerts?graceids=${eventId}`;
    },
  },
});
</script>

<style scoped>
  h2 {
    font-size: 1.1rem;
    font-weight: bold;
  }
  .external-link {
    font-size: 0.9rem;
  }
</style>
